/*  Copyright (C) 1997 Brian Raiter
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 */

#define	OT_PEN			1
#define	OT_BRUSH		2
#define	OT_FONT			3
#define	OT_PALETTE		4
#define	OT_BITMAP		5
#define	OT_REGION		6
#define	OT_DC			7
#define	OT_DCDISABLED		8
#define	OT_METADC		9
#define	OT_METAFILE		10
#define	OT_METAFILEDC		11
#define	OT_CURSOR		12
#define	OT_ICON			13
#define	OT_MENU			14

#define	DSPM_DISPLAYCLOSE	(WM_USER+100)
#define	DSPM_OUTOFROOM		(WM_USER+101)
#define	LSTM_OPENOBJECT		(WM_USER+200)

#define	IDM_OPEN		2000
#define	IDM_DELETE		2100
#define	IDM_MARKDELETE		2101
#define	IDM_ABOUT		2200

#define	IDC_LIST		100

#define	IDR_MENU		1
#define	IDR_ICON		2

#ifndef	RC_INVOKED


#define	ERRORBOX(MSG)	MessageBox(GetFocus(), MSG, "Error",		\
					MB_ICONEXCLAMATION | MB_OK)
#define	FATALERROR(MSG)	MessageBox(GetFocus(), MSG, "Fatal Error",	\
					MB_ICONSTOP | MB_OK)

#define	NEFLAGS_OFFSET	0x000C
#define	NEFLAG_DLL	0x8000

#define	GETOBJECTOWNER(SEG, HOBJ)	\
		(*(HTASK FAR*)((BYTE FAR*)MAKELP(SEG, HOBJ) + 0x0C))

typedef	struct tagRGNOBJ {
		int	fType;
		RECT	rcBox;
	} RGNOBJ, FAR* LPRGNOBJ;
typedef const FAR* LPCRGNOBJ;

typedef	int (*OBJDESCRIBEPROC)(char*, void*);
typedef	void (*OBJWNDSIZEPROC)(void*, SIZE*);
typedef void (*OBJPAINTPROC)(HDC, RECT*, HGDIOBJ, void*, char*, int, SIZE*);

typedef	struct tagOBJINFO {
		HGDIOBJ		hgdiobj;
		int		fType;
		HANDLE		hOwner;
	} OBJINFO, FAR* LPOBJINFO;
typedef	const FAR* LPCOBJINFO;

typedef	struct tagOBJDISPINFO {
		HGDIOBJ		hgdiobj;
		int		fType;
		OBJPAINTPROC	pfnPainter;
		char*		szDesc;
		int		cbDesc;
		SIZE		sizeDesc;
		BYTE		logobj[1];
	} OBJDISPINFO, FAR* LPOBJDISPINFO;
typedef	const FAR* LPCOBJDISPINFO;


struct tagDISPLAYEXTRABYTES {
	OBJDISPINFO*	pobjdi;
	BOOL		bDelete;
};
#define	CBDSPWNDEXTRA		(sizeof(struct tagDISPLAYEXTRABYTES))
#define	DSPXB(FLD)		(FIELDOFFSET(struct tagDISPLAYEXTRABYTES, FLD))

struct tagLISTEXTRABYTES {
	int		xStart;
	int		yStart;
	int		xDisplay;
	int		yDisplay;
	int		nDispWnds;
};
#define	CBLSTWNDEXTRA		(sizeof(struct tagLISTEXTRABYTES))
#define	LSTXB(FLD)		(FIELDOFFSET(struct tagLISTEXTRABYTES, FLD))


extern OBJPAINTPROC	pfnPainters[];
extern HINSTANCE	ghinstApp;
extern OBJINFO		gobjMine[16];
extern const char	*gszName[];
extern char		gszScratch[1024];
extern int		gnMargin;
extern int		gcxMaxWnd, gcyMaxWnd;
extern WORD		gsegGDI;


void _cdecl DebugPrintf(char*, ...);
int WINAPI GetRegion(HGDIOBJ, int, LPVOID);
void UnmakeObject(HGDIOBJ, int);

OBJDISPINFO* FillObjInfoStruct(HGDIOBJ, int);

void AddObjectToMyList(HGDIOBJ, int, BOOL);
BOOL IsObjectMine(HGDIOBJ, int);
HWND CreateDisplayWindow(HWND, HGDIOBJ, int, int, int);

int VerifyObject(WORD, HGDIOBJ);

LRESULT _export CALLBACK ObjectDisplayWndProc(HWND, UINT, WPARAM, LPARAM);
LRESULT _export CALLBACK ObjectListWndProc(HWND, UINT, WPARAM, LPARAM);


#endif	/* RC_INVOKED */
