/* lifeids.h: Resource and dialog control identifiers.			*/
/*									*/
/* (C) 1997 by Brian Raiter, under the terms of the GNU General Public	*/
/* License ver. 2 (or any later version, if you like).			*/

#ifndef	__LIFEIDS_H__
#define	__LIFEIDS_H__


/* Thoth menu items */
#define	IDM_ERASE	100
#define	IDM_RANDOMFILL	101
#define	IDM_RPENTOMINO	102
#define	IDM_ACORN	103
#define	IDM_OPEN	110
#define	IDM_SAVE	112
#define	IDM_RESIZE	120
#define	IDM_EXIT	199

/* Ra menu items */
#define	IDM_COPY	210
#define	IDM_PASTE	211
#define	IDM_RAISEMAG	220
#define	IDM_LOWERMAG	221
#define	IDM_1STGEAR	230
#define	IDM_OVERDRIVE	231
#define	IDM_SETCOLORS	240
#define	IDM_PALETTED	241

/* Ptah menu items */
#define	IDM_GO		300
#define	IDM_STOP	301
#define	IDM_GEN0	310
#define	IDM_GEN1	311
#define	IDM_GEN2	312
#define	IDM_GEN3	313
#define	IDM_GEN4	314
#define	IDM_GEN5	315
#define	IDM_GEN6	316
#define	IDM_GEN7	317
#define	IDM_GEN8	318
#define	IDM_GEN9	319
#define	IDM_GENMAX	IDM_GEN9
#define	IDM_TIME	390
#define	IDM_BENCHMARK	391

/* Help menu items */
#define	IDM_ABOUT	999

/* Popup menu positions */
#define	MENUPOS_THOTH	0
#define	MENUPOS_PTAH	1
#define	MENUPOS_RA	2
#define	MENUPOS_HELP	3

/* Dialog boxes */
#define	IDD_ABOUT	1000
#define	IDD_RESIZE	2000
#define	IDD_COLORS	3000

/* Resize dialog controls */
#define	IDC_WIDTH	2010
#define	IDC_HEIGHT	2011
#define	IDC_MAG		2020

/* Colors dialog controls */
#define	IDC_RED		3010
#define	IDC_GRN		3011
#define	IDC_BLU		3012
#define	IDC_HUE		3020
#define	IDC_LUM		3021
#define	IDC_SAT		3022
#define	IDC_RVAL	3030
#define	IDC_GVAL	3031
#define	IDC_BVAL	3032
#define	IDC_HVAL	3040
#define	IDC_LVAL	3041
#define	IDC_SVAL	3042
#define	IDC_SCRLVALDIFF	(IDC_RVAL - IDC_RED)
#define	IDC_COLOR	3050
#define	IDC_BKGND	3060
#define	IDC_FRAME	3061
#define	IDC_TEXT	3062
#define	IDC_EMPTY	3063
#define	IDC_ALIVE	3064
#define	IDC_ZYGOTE	3065
#define	IDC_DYING	3066
#define	IDC_SETBKGND	3070
#define	IDC_SETFRAME	3071
#define	IDC_SETTEXT	3072
#define	IDC_SETEMPTY	3073
#define	IDC_SETALIVE	3074
#define	IDC_SETZYGOTE	3075
#define	IDC_SETDYING	3076
#define	IDC_REVERT	3080
#define	IDC_RADIO1ST	IDC_BKGND
#define	IDC_RADIOLAST	IDC_DYING
#define	IDC_SETBTN1ST	IDC_SETBKGND
#define	IDC_SETBTNLAST	IDC_SETDYING

/* Strings */
#define	IDS_GEN		0x0001
#define	IDS_POP		0x0002
#define	IDS_MAXWORDLEN	0x0011
#define	IDS_FILTERS	0x0020
#define	IDS_EXTS	0x0021
#define	IDS_OPENFILE	0x0022
#define	IDS_SAVEFILE	0x0024
#define	IDS_FILEERR	0x0025
#define	IDS_CANTOPEN	0x0026
#define	IDS_CANTREAD	0x0027
#define	IDS_CANTWRITE	0x0028
#define	IDS_NOTXTFILES	0x0029
#define	IDS_GMEMERR	0x0030
#define	IDS_NULLH	0x0031
#define	IDS_BADPTR	0x0032
#define	IDS_NOMEM	0x0033
#define	IDS_RESIZE	0x0040
#define	IDS_SIZELIMIT	0x0041
#define	IDS_GDIERR	0x0050
#define	IDS_CANTINIT	0x0051
#define IDS_NEED386	0x0060
#define	IDS_CALCERR	0xFFFF


#endif	/*  __LIFEIDS_H__  */
